/*---------------------------------------------------------------------------*\
  =========                 |
  \\      /  F ield         | OpenFOAM: The Open Source CFD Toolbox
   \\    /   O peration     |
    \\  /    A nd           | Copyright (C) 1991-2009 OpenCFD Ltd.
     \\/     M anipulation  |
-------------------------------------------------------------------------------
License
    This file is part of OpenFOAM.

    OpenFOAM is free software; you can redistribute it and/or modify it
    under the terms of the GNU General Public License as published by the
    Free Software Foundation; either version 2 of the License, or (at your
    option) any later version.

    OpenFOAM is distributed in the hope that it will be useful, but WITHOUT
    ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
    FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
    for more details.

    You should have received a copy of the GNU General Public License
    along with OpenFOAM; if not, write to the Free Software Foundation,
    Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110-1301 USA

Class
    Foam::basicAbscheideParcel

Description


SourceFiles
    basicAbscheideParcel.C

\*---------------------------------------------------------------------------*/

#ifndef basicAbscheideParcel_H
#define basicAbscheideParcel_H

#include "KinematicParcel.H"

// * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * //

namespace Foam
{

/*---------------------------------------------------------------------------*\
                   Class basicAbscheideParcel Declaration
\*---------------------------------------------------------------------------*/

class basicAbscheideParcel
:
    public KinematicParcel<basicAbscheideParcel>
{

public:

    //- Run-time type information
    TypeName("basicAbscheideParcel");


    // Constructors

        //- Construct from components
        basicAbscheideParcel
        (
            KinematicCloud<basicAbscheideParcel>& owner,
            const label typeId,
            const vector& position,
            const label cellI,
            const scalar d0,
            const vector& U0,
            const scalar nParticle0,
            const constantProperties& constProps
        );

        //- Construct from Istream
        basicAbscheideParcel
        (
            const Cloud<basicAbscheideParcel>& c,
            Istream& is,
            bool readFields = true
        );

        //- Construct as a copy
        basicAbscheideParcel(const basicAbscheideParcel& p);

         //- Construct and return a clone
        autoPtr<basicAbscheideParcel> clone() const
        {
            return
                autoPtr<basicAbscheideParcel>
                (
                    new basicAbscheideParcel(*this)
                );
        }

            void hitPatch
            (
                const polyPatch&,
                trackData& td
            );

           void hitPatch
            (
                const polyPatch&,
                int&
            );

    //- Destructor
    virtual ~basicAbscheideParcel();
};

template<>
inline bool contiguous<basicAbscheideParcel>()
{
    return true;
}


// * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * //

} // End namespace Foam

// * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * //

#endif

// ************************************************************************* //
